import controlP5.*;

ControlP5 cp5;
Textarea myTextarea;
PFont font;

String msg1 = "・スライダーを動かすとサイズが変わる\n"
            + "・TABキーを押すと次メッセージを表示\n"
            + "・INPUTに文字を入力するとここに追加\n"
            + "　（ただし、漢字入力はできない）\n";

String msg2 = "・CLRボタンを押すと消去されす\n"
            + "・BSキーを押すと元メッセージを表示\n";

void setup() {
  size(640,400);
  cp5 = new ControlP5(this);
  font = createFont("MS-Gothic-48",14);
 
  myTextarea = cp5.addTextarea("txt")
                  .setPosition(80,60)
                  .setSize(200,200)
                  .setFont(font)
                  .setLineHeight(18)
                  .setColor(color(255))
                  .setColorBackground(color(0,0))
                  .setColorForeground(color(255,255));
                  ;
  myTextarea.setText(msg1);
    
  cp5.addSlider("sWidth")
     .setRange(100,360)
     .setValue(300)
     .setPosition(100,20)
     .setSize(200,25)
     .setSliderMode(Slider.FLEXIBLE)
     ;
  cp5.getController("sWidth").getCaptionLabel().setVisible(false);
       
  cp5.addSlider("sHeight")
     .setRange(320,100)
     .setValue(250)
     .setPosition(30,80)
     .setSize(20,200)
 //    .setColorBackground(color(255,255,9))
     .setSliderMode(Slider.FLEXIBLE)
     ;
  cp5.getController("sHeight").getCaptionLabel().setVisible(false);
  
  cp5.addTextfield("input")
     .setPosition(400,20)
     .setSize(200,30)
     .setFont(font)
     .setFocus(true)
     .setColor(color(255,255,0))
     ;
   cp5.getController("input")
     .getCaptionLabel()
     .align(ControlP5.LEFT_OUTSIDE,ControlP5.CENTER)
     .setPaddingX(0)
     ;
     
   cp5.addButton("cBtn")
      .setPosition(30,20)
      .setSize(30,30)
      .setCaptionLabel("clr")
      .setColorBackground(color(255,0,0))
      ;
 }

void keyPressed() {
    if(key == TAB){
      myTextarea.setText(msg2);
    }
    else if(key == BACKSPACE){
      myTextarea.setText(msg1);
    }
}

void draw() {
  background(96);
  if(keyPressed && key==' ') {
//    myTextarea.scroll((float)mouseX/(float)width);
//  }
//  if(keyPressed && key=='l') {
    myTextarea.setLineHeight(mouseY);
  }
}

void sWidth(int theValue) {
  myTextarea.setWidth(theValue);
}

void sHeight(int theValue) {
  myTextarea.setHeight(theValue);
}
public void input(String theText) {
  // automatically receives results from controller input
  println("a textfield event for controller 'input' : "+theText);
    myTextarea.append(theText+"\n");  
}

public void cBtn(int theValue){
    myTextarea.clear();  
}
